SoBumpMapMatrixElement Class Reference
Element Classes

The SoBumpMapMatrixElement class is used to manage the bump map matrix stack. More...

`#include <Inventor/elements/SoBumpMapMatrixElement.h>`

Inheritance diagram for SoBumpMapMatrixElement:

## Public Member Functions

virtual void | init (SoState *state)
virtual void | push (SoState *state)
Public Member Functions inherited from SoAccumulatedElement
virtual SbBool | matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions

static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | makeIdentity (SoState *const state, SoNode *const node)
static void | set (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | mult (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | translateBy (SoState *const state, SoNode *const node, const SbVec3f &translation)
static void | rotateBy (SoState *const state, SoNode *const node, const SbRotation &rotation)
static void | scaleBy (SoState *const state, SoNode *const node, const SbVec3f &scaleFactor)
static const SbMatrix & | get (SoState *const state)
Static Public Member Functions inherited from SoAccumulatedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions

virtual | ~SoBumpMapMatrixElement ()
virtual void | makeEltIdentity (void)
virtual void | setElt (const SbMatrix &matrix)
virtual void | multElt (const SbMatrix &matrix)
virtual void | translateEltBy (const SbVec3f &translation)
virtual void | rotateEltBy (const SbRotation &rotation)
virtual void | scaleEltBy (const SbVec3f &scaleFactor)
virtual const SbMatrix & | getElt (void) const
Protected Member Functions inherited from SoAccumulatedElement
virtual | ~SoAccumulatedElement ()
void | clearNodeIds (void)
void | addNodeId (const SoNode *const node)
void | setNodeId (const SoNode *const node)
void | copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * | copyMatchInfo (void) const
virtual void | captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes

SbMatrix | bumpMapMatrix
Protected Attributes inherited from SoAccumulatedElement
SbList< SbUniqueId > | nodeIds
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members

Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoBumpMapMatrixElement class is used to manage the bump map matrix stack.

The bump map matrix is used to transform bump map coordinates before being used to map bump maps onto polygons.

## Constructor & Destructor Documentation

## ~SoBumpMapMatrixElement()

SoBumpMapMatrixElement::~SoBumpMapMatrixElement | ( | void |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoBumpMapMatrixElement::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getClassStackIndex()

int SoBumpMapMatrixElement::getClassStackIndex | ( | void |  | ) |

static

This static method returns the state stack index for the class.

## createInstance()

void * SoBumpMapMatrixElement::createInstance | ( | void |  | ) |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## initClass()

void SoBumpMapMatrixElement::initClass | ( | void |  | ) |

static

Initialize relevant common data for all instances, like the type system.

## init()

void SoBumpMapMatrixElement::init | ( | SoState * | state | ) |

virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoAccumulatedElement.

## push()

void SoBumpMapMatrixElement::push | ( | SoState * | state | ) |

virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoAccumulatedElement.

## makeIdentity()

void SoBumpMapMatrixElement::makeIdentity | ( | SoState *const | state,
|  | SoNode *const | node )

static

Sets current texture matrix to identity.

## set()

void SoBumpMapMatrixElement::set | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbMatrix & | matrix )

static

Sets the current texture matrix to matrix.

This method is an extension versus the Open Inventor API.

## mult()

void SoBumpMapMatrixElement::mult | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbMatrix & | matrix )

static

Multiplies matrix into the current texture matrix.

## translateBy()

void SoBumpMapMatrixElement::translateBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbVec3f & | translation )

static

Appends translation to the current texture matrix.

## rotateBy()

void SoBumpMapMatrixElement::rotateBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbRotation & | rotation )

static

Appends rotation to the current texture matrix.

## scaleBy()

void SoBumpMapMatrixElement::scaleBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbVec3f & | scaleFactor )

static

Appends scaleFactor to the current texture matrix.

## get()

const SbMatrix & SoBumpMapMatrixElement::get | ( | SoState *const | state | ) |

static

Returns current texture matrix.

## makeEltIdentity()

void SoBumpMapMatrixElement::makeEltIdentity | ( | void |  | ) |

protected virtual

virtual method which is called from makeIdentity(). Sets element matrix to identity.

## setElt()

void SoBumpMapMatrixElement::setElt | ( | const SbMatrix & | matrix | ) |

protected virtual

virtual method which is called from set(). Sets the texture matrix to matrix.

This method is an extension versus the Open Inventor API.

## multElt()

void SoBumpMapMatrixElement::multElt | ( | const SbMatrix & | matrix | ) |

protected virtual

virtual method which is called from mult(). Multiplies matrix into element matrix.

## translateEltBy()

void SoBumpMapMatrixElement::translateEltBy | ( | const SbVec3f & | translation | ) |

protected virtual

virtual method which is called from translateBy(). Appends translation to the element matrix.

## rotateEltBy()

void SoBumpMapMatrixElement::rotateEltBy | ( | const SbRotation & | rotation | ) |

protected virtual

virtual method which is called from rotateBy(). Appends rotation to the element matrix.

## scaleEltBy()

void SoBumpMapMatrixElement::scaleEltBy | ( | const SbVec3f & | scaleFactor | ) |

protected virtual

virtual method which is called from scaleBy(). Append scaleFactor to the element matrix.

## getElt()

const SbMatrix & SoBumpMapMatrixElement::getElt | ( | void |  | ) | const

protected virtual

Returns element matrix. Called from get().

## Member Data Documentation

## bumpMapMatrix

SbMatrix SoBumpMapMatrixElement::bumpMapMatrix

protected

The matrix.

The documentation for this class was generated from the following files:

- SoBumpMapMatrixElement.h
- SoBumpMapMatrixElement.cpp